'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomInput-addon';

var TYPES = {
  LEFT: 'left',
  RIGHT: 'right'
};

var AddonHoC = function AddonHoC(WrappedInput) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    (0, _inherits3.default)(Addon, _React$Component);

    function Addon() {
      (0, _classCallCheck3.default)(this, Addon);
      return (0, _possibleConstructorReturn3.default)(this, (Addon.__proto__ || (0, _getPrototypeOf2.default)(Addon)).apply(this, arguments));
    }

    (0, _createClass3.default)(Addon, [{
      key: 'getClassName',
      value: function getClassName(_ref) {
        var type = _ref.type;

        return (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '--' + type);
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            leftAddon = _props.leftAddon,
            rightAddon = _props.rightAddon,
            props = (0, _objectWithoutProperties3.default)(_props, ['leftAddon', 'rightAddon']);

        return _react2.default.createElement(
          'div',
          { className: 'sui-AtomInput-addonWrapper' },
          leftAddon && _react2.default.createElement(
            'span',
            { className: this.getClassName({ type: TYPES.LEFT }) },
            leftAddon
          ),
          _react2.default.createElement(WrappedInput, props),
          rightAddon && _react2.default.createElement(
            'span',
            { className: this.getClassName({ type: TYPES.RIGHT }) },
            rightAddon
          )
        );
      }
    }]);
    return Addon;
  }(_react2.default.Component), _class.propTypes = {
    /* Left addon component, text,... */
    leftAddon: _propTypes2.default.any,
    /* Right addon component, text,... */
    rightAddon: _propTypes2.default.any
  }, _temp;
};

exports.default = AddonHoC;