'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inputSizes = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Addon = require('./Features/Addon');

var _Addon2 = _interopRequireDefault(_Addon);

var _Component = require('./Component');

var _Component2 = _interopRequireDefault(_Component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WithAddonComponent = (0, _Addon2.default)(_Component2.default);

exports.default = function (props) {
  var leftAddon = props.leftAddon,
      rightAddon = props.rightAddon; // eslint-disable-line react/prop-types

  if (leftAddon || rightAddon) return _react2.default.createElement(WithAddonComponent, props);
  return _react2.default.createElement(_Component2.default, props);
};

exports.inputSizes = _Component.inputSizes;